1345.Jump Game IV
===
###### tags: `Hard`,`Array`,`Hash Table`,`BFS`
[1345. Jump Game IV](https://leetcode.com/problems/jump-game-iv/)
### 題目描述
Given an array of integers `arr`, you are initially positioned at the first index of the array.
In one step you can jump from index `i` to index:
* `i + 1` where: `i + 1` < `arr.length`.
* `i - 1` where: `i - 1` >= 0.
* `j` where: `arr[i] == arr[j]` and `i != j`.
Return *the minimum number of steps* to reach the **last index** of the array.
Notice that you can not jump outside of the array at any time.
### 範例
**Example 1:**
```
Input: arr = [100,-23,-23,404,100,23,23,23,3,404]
Output: 3
Explanation: You need three jumps from index 0 --> 4 --> 3 --> 9. Note that index 9 is the last index of the array.
```
**Example 2:**
```
Input: arr = [7]
Output: 0
Explanation: Start index is the last index. You do not need to jump.
```
**Example 3:**
```
Input: arr = [7,6,9,6,9,6,9,7]
Output: 1
Explanation: You can jump directly from index 0 to index 7 which is last index of the array.
```
**Constraints**:
* 1 <= `arr.length` <= 5 * 10^4^
* -10^8^ <= `arr[i]` <= 10^8^
### 解答
#### C++
```cpp=
class Solution {
public:
int minJumps(vector<int>& arr) {
int n = arr.size();
unordered_map<int, vector<int>> m;
for (int i = 0; i < n; i++) m[arr[i]].push_back(i);
vector<bool>visited(n, false);
queue<int>q;
q.push(0);
for (int step = 0; !q.empty(); step++) {
for (int t = q.size(); t > 0; t--) {
int i = q.front();
q.pop();
if (i == n - 1) return step;
if (i + 1 < n && !visited[i + 1]) {
visited[i + 1] = true;
q.push(i + 1);
}
if (i - 1 >= 0 && !visited[i - 1]) {
visited[i - 1] = true;
q.push(i - 1);
}
for (int j : m[arr[i]]) {
if (!visited[j]) {
visited[j] = true;
q.push(j);
}
}
m[arr[i]].clear();
}
}
return 0;
}
};
```
> [name=Yen-Chi Chen][time=Mon, Mar 6, 2023]
#### Python
```python=
class Solution:
def minJumps(self, arr: List[int]) -> int:
n = len(arr)
d = defaultdict(list)
for i in range(n):
d[arr[i]].append(i)
curr = [0]
visited = {0}
step = 0
while curr:
children = []
for i in curr:
if i == n - 1: return step
for j in d[arr[i]]:
if j not in visited:
visited.add(j)
children.append(j)
d[arr[i]].clear()
for j in [i - 1, i + 1]:
if 0 <= j < n and j not in visited:
visited.add(j)
children.append(j)
curr = children
step += 1
return -1
```
> [name=Yen-Chi Chen][time=Mon, Mar 6, 2023]
### Reference
[回到題目列表](https://hackmd.io/@Marsgoat/leetcode_every_day)